inittrap:
	clr	EA		; disable interrupts
	mov	dptr,#trapper
	mov	a,#3
	call	setint
	setb	INT0		; clear interrupt
;	setb	PX0		; priority
	clr	IT0		; ext int 0 mode control, low level generates
	setb	EX0		; enable external int 0
  	setb	EA		; enable all
	ret
	
; b has # of function
; other regs as required
trapper:
	push	dpl
	push	dph		; save dptr
	push	acc
	pushreg	r0
	mov	a,b
	mov	b,#3		; ljmp size
	mul	ab
	mov	dptr,#funbas
	add	a,dpl
	mov	dpl,a
	mov	a,b
	addc	a,dph
	mov	dph,a
	mov	r0,sp
	dec	r0		; past r0
	dec	r0		; past acc
	mov	a,dph
	xch	a,@r0		; high function on stack
	mov	dph,a		; restore dph
	dec	r0		; past dph
	mov	a,dpl
	xch	a,@r0		; low function on stack
	mov	dpl,a		; restore dpl
	popreg	r0
	pop	acc
	setb	int0		; clear request
	reti

