; caller must have div16.asm included
;R0	= string address
;R1	= string size
;R2	= base 2,8,10,16
;r6&r7	= integer value

basex:	mov	a,r0		; buff addr
	add	a,r1		; point to end of string
	inc	r1		; 1 more for loop
	mov	r0,a		; start at end
	clr	a		; string terminator
bx0:	mov	@r0,a		; store ascii char
	dec	r0
	mov	a,r2
	mov	r4,a
	mov	r5,#0		; extend base
	pushreg	r0		; save string address
	pushreg	r1		; save string size
	pushreg	r2		; save base
	lcall	div16		; remainder in r4 & r5
	popreg	r2
	popreg	r1
	popreg	r0
	mov	a,r4		; get remainder
	cjne	a,#10,bx3
bx3:	jc	bx2
	add	a,#7
bx2:	add	a,#'0'
	djnz	r1,bx0
	ret

