; Batch processing
; get a node from the WAIT list
; decrement ticks, if ticks = 0
; then add to EXEC list
; process header ready to go from insert function
;
timer_queue:
	mov	dptr,#WAIT
	mov	a,r1
	push	acc			; save r1
sl1:	mov	r1,dpl			; r1 = previous node
	movx	a,@dptr			; next node low
	jnz	sl2			; end of list ?
	pop	acc
	mov	r1,a			; restore r1
	ret				; yes, return to clock
sl2:	mov	r0,a			; r0 = current node
	add	a,#QTICK
	mov	dpl,a
	clr	c
	movx	a,@dptr
	subb	a,#1			; tick = tick - 1
	movx	@dptr,a
	mov	b,a			; save for zero check
	inc	dptr
	movx	a,@dptr
	subb	a,#0			; word extend
	movx	@dptr,a
	orl	a,b			; = 0 ?
	mov	dpl,r0			; DPTR = current node
	jz	sl3			; yes, execute it
	jmp	sl1
;
; this does a 'remque' on current node
sl3:	movx	a,@dptr			; next lo from current
	mov	dpl,r1
	movx	@dptr,a			; previous lo
	mov	a,r0			; A has node to insert
	mov	dptr,#EXEC
	call	insque			; add job to execute list
	pop	acc
	mov	r1,a			; restore r1
	sjmp	timer_queue
$eject	

