; calling program must include z80.inc

;input:
; r4 & r5 have divisior
; r6 & r7 have dividend
;output:
; r6 & r7 = quotient
; r4 & r5 = remainder
;notes:
; b reg saved
div16:	push	b
	mov	a,Ereg		; negate the divisor
	cpl	a
	add	a,#1
	mov	Creg,a
	mov	a,Dreg
	cpl	a
	addc	a,#0
	mov	Breg,a

	mov	a,Hreg
	mov	Dreg,a
	mov	a,Lreg
	mov	Ereg,a
	mov	Hreg,#0
	mov	Lreg,#0
	mov	b,#17
dv0:	pushhl			; save remainder
	clr	c
	dadb			; subtract divisor by negative addition
	jnc	dv1
	xthl			; save new remainder
	setb	c
dv1:	pophl			; restore remainder
	mov	a,Ereg		; CY->E->D->L->H
	rlc	a
	mov	Ereg,a
	mov	a,Dreg
	rlc	a
	mov	Dreg,a
	mov	a,Lreg
	rlc	a
	mov	Lreg,a
	mov	a,Hreg
	rlc	a
	mov	Hreg,a
	djnz	b,dv0
; post divide cleanup
	clr	c
	mov	a,Hreg
	rrc	a
	xch	a,Dreg
	mov	Hreg,a
	mov	a,Lreg
	rrc	a
	xch	a,Ereg
	mov	Lreg,a
	pop	b
	ret

