rdimem:	mov	dptr,#rdimi+1
	mov	a,r0		; get int mem addr
	movx	@dptr,a		; store addr to read
rdimi:	mov	a,0		; read it
	ret
;
wrimem:	mov	dptr,#wrimi+1
	mov	b,a		; save data
	mov	a,r0		; get addr to write
	movx	@dptr,a		; store addr
	mov	a,b		; get data
wrimi:	mov	0,a		; store data
	ret
;
INTMEM:	mov	a,43h
	cjne	a,#0,imerr	; src internal mem only has one page
	mov	a,45h
	cjne	a,#0,imerr	; dst must be page 0 also
	mov	r0,42h
	jb	filler,filint	; fill request
imore:	call	crlf
	mov	a,r0		; get address
	call	prtrad
	call	ilprt
	db	': ',0
	mov	r3,#16		; do 16 bytes per line
imlup:	mov	a,#' '
	call	sndchr
	call	rdimem		; read ANY internal memory
	call	prtrad
	mov	a,r0
	cjne	a,44h,imok	; at dst ?
	ret
imok:	inc	r0
	call	CHKBRK
	djnz	r3,imlup
	ajmp	imore
; store internal mem value
filint:	mov	a,47h		; fill val is byte only
	cjne	a,#0,imerr
imfil:	mov	a,46h		; get fill byte
	call	wrimem		; write ANY internal memory
	mov	a,r0
	cjne	a,44h,imf2	; at dst ?
	ret
imf2:	inc	r0
	ajmp	imfil
imerr:	dec	sp
	dec	sp
	jmp	BADPRM

