;18H = WORD # 0H-10H
;19H = BIT ROTATION POSITION 01H-80H


BUFFER  EQU     4100H           ;LOCATION OF BUFFER


        ORG     4003H           ;INT0 VECTOR

EXT1    PUSH    ACC             ;SAVE ALL
        PUSH    DPH
        PUSH    DPL
        MOV     DPTR,#BUFFER    ;POINT TO BUFFER
        JNB     P3.3,AAA        ;CHECK DATA, JUMP IF '0'
        MOV     A,DPL           ;ELSE GET LSB OF BUFFER ADDRESS
        CLR     C
        ADD     A,18H           ;ADD THE BYTE COUNT OFFSET
        MOV     DPL,A           ;PUT BACK THE LSB
        JNC     BBB             ;CHECK CARRY, JUMP IF NONE
        INC     DPH             ;ELSE ADJUST MSB OF BUFFER ADDRESS
BBB     MOVX    A,@DPTR         ;GET BYTE FROM BUFFER
        ORL     A,19H           ;OR IN A '1' AT BIT POSITION OF REG 19H
        MOVX    @DPTR,A         ;PUT IT BACK IN THE BUFFER

AAA     MOV     A,19H           ;GET BIT POSITION
        RR      A               ;ROTATE IT TO NEXT
        MOV     19H,A           ;PUT IT BACK
        CJNE    A,#80H,CCC      ;JUMP IF NEW BIT POSITION IS NOT BIT-7
        INC     18H             ;ELSE BUMP UP BYTE COUNT

CCC     POP     DPL             ;RETURN ALL 
        POP     DPH
        POP     ACC
        POP     PSW             ;BASIC REQUIRES THIS EXTRA POP
        RETI                    ;THAT'S ALL FOLKS

END     END

