
flags		data	20h
TFLAG		bit	20h.0	; transmit done
RFLAG		BIT	20h.1	; receive ready
nflag		bit	20h.2	; note/velocity
ours		bit	20h.3	; channel 
onoff		bit	20h.4	; note on/off
loopthru	bit	20h.5	; input to output

buffer		equ	30h

relay		data	40h	; storage for whats on p1
channel		data	41h	; selected channel to listen for
beat		data	42h
function	data	43h
instrument	data	44h
status		data	45h
note		data	46h
velocity	data	47h
checksum	data	48h
bank		data	49h
nbytes		data	4ah
nxtmem_lo	data	4eh
nxtmem_hi	data	4fh

maxinst		equ	8	; maximum number of 'instruments'

led0	bit	p1.0
led1	bit	p1.1
led2	bit	p1.2
led3	bit	p1.3
led4	bit	p1.4
led5	bit	p1.5
led6	bit	p1.6
led7	bit	p1.7
; can't use bit	p3.2 cause its for trapper
led8	bit	p3.3
; can't use bit p3.4 cause its for timer 0
runlite	bit	p3.5

pushreg	macro	arg
	mov	a,arg
	push	acc
	endm

popreg	macro	arg
	pop	acc
	mov	arg,a
	endm

trap	macro	arg
	setb	ie0		; set interrupt
	nop			; give interrupt a chance
	db	arg		; function number
	endm
;
; trapper functions
getd	equ	0
putd	equ	1
pow2	equ	2

funbas	equ	30h
getchr	equ	funbas+0
sndchr	equ	funbas+3
power	equ	funbas+6

