; requires z80.inc
;r6 & r7 have multiplicand (HL)
;r4 & r5 have multiplier (DE)
;r4, r5, r6 & r7 have result
mul16:	pushbc
	mov	a,Lreg
	mov	Creg,a
	mov	a,Hreg
	mov	Breg,a		; r2&r3 = multiplicand
	mov	r6,#0
	mov	r7,#0
	mov	r1,#16		; do 16 bits
mloop:	xchg
	dadh			; shift multiplier bit to carry
	push	psw
	xchg
	dadh			; result * 2
	jnc	mjump1		; ok
	incde
mjump1:	pop	psw		; get multiplier bit
	jnc	mjump3
	dadb			; result = result + multiplier
mjump2:	jnc	mjump3
	incde
mjump3:	djnz	r1,mloop
	popbc
	ret

