set_vert:
	mov	r2,#0ffh
	mov	dptr,#voltab	; table of voltage settings
svolt2:	movx	a,@dptr		; get key
	inc	r2
	inc	dptr		; point to value
	cjne	a,#0ffh,svolt4	; end of table ?
	sjmp	svolt3		; yes, exit
svolt4:	cjne	a,b,novolt	; found it ?
	movx	a,@dptr		; yes, get voltage setting
svolt3:	mov	volt,r2
	mov	dptr,#p6	; point to D/A
	movx	@dptr,a		; set A/D reference voltage
	ret			; all done
novolt:	inc	dptr		; next item
	sjmp	svolt2		; continue

VOLTAB:	DB	'Q',250		; 5v
	DB	'W',100		; 2v
	DB	'E',50		; 1v
	DB	'R',25		; .5v
	DB	'T',10		; .2v
	DB	'Y',5		; .1v
	DB	0FFH
;
; show vertical volts per division
show_vert:
	mov	r2,#1		; row
	mov	r3,#0		; col
	acall	set_cursor
	call	ilprt
	db	alpha,'Vert div: ',0
	mov	dptr,#perdiv
	mov	a,volt
	mov	b,#5
	mul	ab
	add	a,dpl
	mov	dpl,a
	mov	a,b
	addc	a,dph
	mov	dph,a
svert1:	movx	a,@dptr	
	jz	svert2
	call	sndchr
	inc	dptr
	sjmp	svert1
svert2:	mov	a,#'v'
	call	sndchr
	ret
;
perdiv:
vmsg1:	db	'1.25',0
vmsg2:	db	'.5  ',0
vmsg3:	db	'.25 ',0
vmsg4:	db	'.125',0
vmsg5:	db	'.05 ',0
vmsg6:	db	'.025',0

