sndchr:	push	acc			; save output char
	push	psw
	push	dpl
	push	dph
	clr	f0
;
scwfd:	call	instat			; keystroke ?
	jnc	nobrk			; no
	mov	dptr,#rhead
	movx	a,@dptr			; get head pointer
	mov	dpl,a
	movx	a,@dptr			; get data
	cjne	a,#xon,noxon		; stop ?
	call	irhead			; remove xon
	setb	f0			; handshake on
	sjmp	nobrk
noxon:	cjne	a,#xoff,nobrk		; continue ?
	call	irhead			; remove xoff
	clr	f0			; handshake off
nobrk:	jb	f0,scwfd		; loop if xoff
;
	pop	dph
	pop	dpl
	pop	psw
	pop	acc			; get output data
;
forchr:	push	b
	push	dpl
	push	dph
	push	acc		; save data
;
	mov	dptr,#xtail
	movx	a,@dptr		; get xtail
	inc	a		; next position
	anl	a,#03fh		; ring 64 bytes
	setb	acc.7		; always 80 above
	mov	b,a		; save next xtail
	dec	dpl		; point to xhead
xwait:	movx	a,@dptr		; get xhead
	cjne	a,b,xsend	; not equal ok
	sjmp	xwait		; equal, buffer full
;
xsend:	inc	dpl		; point to xtail
	movx	a,@dptr		; get xtail
	xch	a,b		; swap old and new
	movx	@dptr,a		; store new xtail
	mov	dpl,b		; xbuff indexed at tail
	pop	acc		; get data
	push	acc
	movx	@dptr,a		; store data at tail
;
	mov	dpl,#low sflag
	movx	a,@dptr
	jb	acc.tflag,xmiton	; already sending
	setb	acc.tflag		; flag busy
	movx	@dptr,a
	setb	scon.1			; start sending
xmiton:	pop	acc
	pop	dph
	pop	dpl
	pop	b
	ret


