; setting ie0 will force interrupt
inittrap:
	mov	dptr,#3		; external int 0 vector
	mov	a,#02h
	movx	@dptr,a		; ljmp instruction
	inc	dptr
	mov	a,#high trapper
	movx	@dptr,a
	inc	dptr
	mov	a,#low trapper
	movx	@dptr,a
	setb	EX0		; enable external int 0
	ret
	
; stack has address of function number
; other regs as required
trapper:
	push	dpl
	push	dph		; save dptr
	push	acc
	push	b
	pushreg	r0
	push	psw
	mov	a,sp
	clr	c
	subb	a,#6		; get past pushes
	mov	r0,a
	mov	a,@r0		; get high return addr
	mov	dph,a
	dec	r0
	mov	a,@r0		; get low return address
	mov	dpl,a
	movx	a,@dptr		; get function number
	mov	b,a		; save function
	inc	dptr		; skip past function number
	mov	a,dpl
	mov	@r0,a		; new low return back
	inc	r0
	mov	a,dph
	mov	@r0,a		; new high return back
	inc	r0		; point to saved dpl
	mov	a,b		; get function
	mov	b,#3		; ljmp size
	mul	ab
	mov	dptr,#funbas	; function base
	add	a,dpl
	mov	dpl,a
	mov	a,b
	addc	a,dph
	mov	dph,a
	mov	a,dpl
	xch	a,@r0		; low function on stack
	mov	dpl,a		; restore dpl
	inc	r0		; past dpl
	mov	a,dph
	xch	a,@r0		; high function on stack
	mov	dph,a		; restore dph
	pop	psw
	popreg	r0
	pop	b
	pop	acc
	clr	ie0		; clear request
	reti			; do function then return to caller

