$mod51
$nolist
$nosymbols
$include(midi.inc)
; make notes sequential, extracting sharps for last
; this becomes c,d,e,f,g,a,b and all the sharps bit 7
; makes easier to program relays when any c is bit 0
; code is written in PIC (position independent code)
; to allow sysex to load it anywhere and install
; the start address in INSTAB table of ljmps and
; size
$list
;
alter:	mov	a,p0
	add	a,#trans-$	; table offset from here
	mov	dpl,a
	mov	a,p2
	addc	a,#0
	mov	dph,a		; dptr = translation table
	mov	a,note		; get byte
	mov	b,#12
	div	ab		; 12 notes per octave
	mov	a,b		; get remainder, line up notes
	movc	a,@a+dptr	; translate
;	trap	power
	lcall	power
	jb	onoff,altr2
	cpl	a
	xch	a,relay
	anl	a,relay		; force off
	ret
altr2:	orl	a,relay		; mask in previous
	ret			; doit
trans:	db	0,7,1,7,2,3,7,4,7,5,7,6
;
alter_size	equ	$-alter
	end
	
