$mod51
$include(z80.inc)
$include(mon51.inc)
$include(controls.inc)
buff	equ	30h

	cseg
	org	8000h
start:
	call	initgraf

	mov	r3,#2
	mov	dptr,#0		; sin in degrees
	shld	x1
	shld	x2
loop:	push	1
	push	2
	push	3
	push	4
	push	5
	push	dph
	push	dpl
	call	sin		; sin value in r6&r7
;
	mov	a,r7
	clr	acc.7
	mov	r7,a
	
	mov	r4,#30
	mov	r5,#0
	call	div16		; quotient in r6&r7
;
	jnb	f0,posi
	neghl
posi:
	mov	a,r6
	add	a,#low 364			; basline
	mov	dpl,a
	mov	a,r7
	addc	a,#high 364
	mov	dph,a
	shld	y1
	shld	y2
	call	plot
	lhld	x1
	inc	dptr
	shld	x1
	shld	x2
;
	pop	dpl
	pop	dph
	pop	5
	pop	4
	pop	3
	pop	2
	pop	1

	inc	dptr		; next degree
	mov	a,dpl
	subb	a,#low 360
	mov	a,dph
	subb	a,#high 360
	jz	more
	jmp	loop
more:	dec	r3
	mov	a,r3
	jz	done
	mov	dptr,#0
	jmp	loop
done:	ljmp	hot

; dptr =  sin in degrees
sin:	clr	f0		; sign flag
	clr	c
	mov	a,dpl
	subb	a,#181
	mov	r8,a
	mov	a,dph
	subb	a,#0
	jc	le180
	mov	dph,a
	mov	dpl,r8
	inc	dptr		; make sub 180
	setb	f0		; 1 = negative
le180:	clr	c
	mov	a,dpl
	subb	a,#91
	mov	r8,a
	mov	a,dph
	subb	a,#0
	jc	sinlod
	mov	a,#180		; 180 - degrees
	subb	a,dpl
	mov	dpl,a
	mov	a,#0
	subb	a,dph
	mov	dph,a
sinlod:	clr	c
	mov	a,dpl
	rlc	a			; * 2
	mov	dpl,a
	mov	dph,#high sintab
	movx	a,@dptr
	mov	c,f0			; get sign
	mov	acc.7,c			; set sign
	mov	r7,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	ret

$include(basex.asm)

$include(div16.asm)

$include(plot.asm)

$include(dvide8.asm)

	cseg at ($ and 0ff00h) + 100h
$include(c:\temp\sintab.dat)

	dseg at 8400h
string:	ds	16
x1:	ds	2
y1:	ds	2
x2:	ds	2
y2:	ds	2
	end

