counter		data	22h
divisor		equ	24h
dividend 	equ	2ch
; quotient and remainder MUST stay in this order for shift
remainder	equ	28h
quotient	equ	2ch

div32:
; negate the divisor
	mov	r0,#divisor+3
	mov	b,#4
	setb	c		; make 2's compliment
L1:	mov	a,@r0
	cpl	a
	addc	a,#0
	mov	@r0,a
	dec	r0
	djnz	b,L1

; clear remainder
	mov	r0,#remainder
	mov	b,#4
L2:	mov	@r0,#0
	inc	r0
	djnz	b,L2
			
	mov	counter,#33	; number of bits + 1

; save remainder
dvd0:	mov	r0,#remainder
	mov	b,#4
L3:	mov	a,@r0
	push	acc
	inc	r0
	djnz	b,L3

; subtract divisor from remainder
	mov	r0,#divisor+3
	mov	r1,#remainder+3
	clr	c
	mov	b,#4
L4:	mov	a,@r1
	addc	a,@r0
	mov	@r1,a
	dec	r0
	dec	r1
	djnz	b,L4
		
	jnc	dvd1

; overflow - get remainder back
	mov	r1,#remainder+3
	mov	r0,sp
	mov	b,#4
L5:	xch	a,@r1
	xch	a,@r0
	xch	a,@r1
	dec	r0		; next byte
	dec	r1
	djnz	b,L5

	setb	c

; restore remainder
dvd1:	mov	r0,#remainder+3
	mov	b,#4
L6:	pop	acc
	mov	@r0,a
	dec	r0
	djnz	b,L6

; shift results - low quotient through high remainder
	mov	r0,#quotient+3
	mov	b,#8
L7:	mov	a,@r0
	rlc	a
	mov	@r0,a
	dec	r0
	djnz	b,L7

	djnz	counter,dvd0

; post divide cleanup
	clr	c
	mov	r0,#remainder
	mov	b,#4
L9:	mov	a,@r0
	rrc	a
	mov	@r0,a
	inc	r0
	djnz	b,L9
	
	ret

