; input:
; r1 = result address
; r0 = points to buff
; carry set if error
; output:
; value in result address
; r1 = char count
;
GETADDR:
	pushreg	r2
	pushreg	r3
	clr	isbyte
	mov	r7,#0		; char count
	mov	r2,#0		; clear hi addr
	mov	r3,#0		; clear lo addr
ga1:	mov	a,@r0		; nibble loop
	cjne	a,#'.',ga12
	jmp	gadun
ga12:	cjne	a,#'0',ga2	; < 0 ?
ga2:	jc	gadun
	cjne	a,#':',ga3	; > 9 ?
ga3:	jc	cvtval
	cjne	a,#'A',ga4	; < A ?
ga4:	jc	gadun
	cjne	a,#'G',ga5	; > F ? 
ga5:	jnc	gadun
cvtval:	call	aschex
	jc	badadr
	call	rotwrd
	inc	r7		; char count + 1
	inc	r0		; next buff byte
	jmp	ga1
;
gadun:	dec	r0		; unget char in buffer
	push	acc		; save last byte
	mov	a,r3
	mov	@r1,a		; low address
	inc	r1
	mov	a,r2
	mov	@r1,a		; high address
	mov	a,r7		; get char count
	mov	r1,a		; char count to r1
	cjne	a,#2,ga11	; byte value ?
	setb	isbyte
ga11:	pop	acc		; get last byte
	clr	c
gaexit:	popreg	r3
	popreg	r2
	ret
badadr:	setb	c
	jmp	gaexit
;
rotwrd:	push	b
	anl	a,#0fh
	xch	a,r3
	swap	a
	mov	b,a
	anl	a,#0f0h
	orl	a,r3
	mov	r3,a
	mov	a,b
	anl	a,#0fh
	xch	a,r2
	swap	a
	anl	a,#0f0h
	orl	a,r2
	mov	r2,a
	pop	b
	ret
;
$include(aschex.asm)

