$include(settings.inc)
funbas	equ	00100h
;			      bios number
cold	equ	funbas+0	; 0
warm	equ	funbas+3	; 1
hot	equ	funbas+6	; 2
getchr	equ	funbas+9	; 3
sndchr	equ	funbas+12	; 4
print	equ	funbas+15	; 5
ilprt	equ	funbas+18	; 6
prtrad	equ	funbas+21	; 7
prtradw	equ	funbas+24	; 8
prtaddr	equ	funbas+27	; 9
div32	equ	funbas+30	; 10
mul16	equ	funbas+33	; 11
div16	equ	funbas+36	; 12
dvide8	equ	funbas+39	; 13
chkbrk	equ	funbas+42	; 14
crlf	equ	funbas+45	; 15
getln	equ	funbas+48	; 16
getaddr	equ	funbas+51	; 17
basex	equ	funbas+54	; 18
setint	equ	funbas+57	; 19
insrt	equ	funbas+60	; 20
tstop	equ	funbas+63	; 21
psprad	equ	funbas+66	; 22
getrad	equ	funbas+69	; 23
add16	equ	funbas+72	; 24
sub16	equ	funbas+75	; 25
badprm	equ	funbas+78	; 26
prterr	equ	funbas+81	; 27
instat	equ	funbas+84	; 28
irhead	equ	funbas+87	; 29
;
;===============================
$include(float.inc)
;===============================
inbuff	equ	30h
src	data	42h
dst	data	44h
fil	data	46h
radix	data	48h
radsiz	data	49h

runlite	bit	p3.5
bios	bit	int0
ad0	equ	04000h		; analog to digital adc804
p4	equ	06000h		; 8255 port A
p5	equ	06001h		; 8255 port B
p6	equ	06002h		; 8255 port C
p8255	equ	06003h		; 8255 control

int	macro	val
	clr	val		;; trigger interrupt
	nop			;; let controller detect it
	endm

pushreg	macro	arg
	xch	a,arg		;; save acc, get arg
	push	acc		;; put arg on stack
	xch	a,arg		;; get acc
	endm

popreg	macro	arg
	xch	a,arg		;; save acc
	pop	acc		;; get arg from stack
	xch	a,arg		;; restore acc, put arg
	endm


