; ----------------------------------------------------
; PulseOut.asm      Last Update:11/24/92
; Generates pulses
;
; ====================================================
; UIOD connections
;
; Potentiometers AN0-AN7 to inputs AN0-AN7
; ====================================================
;       m a i n    p r o g r a m
; ----------------------------------------------------
; internal memory use
; bytes:
; ----------------------------------------------------
; system calls              registers used
; ----------------------------------------------------
 ascbin    equ  0100h  ; a, r2, error flag
 autoexec  equ  0103h
 beep      equ  0106h  ;  none
 binasc    equ  0109h  ; a
 break     equ  010ch  ; a, (reads accumulator)
 chkbrk    equ  010fh  ; a, (reads serial port)
 cret      equ  0112h  ; a
 crlf      equ  0115h  ; a
 delay     equ  0118h  ; a
 display   equ  011bh  ; a
 getbyt    equ  011eh  ; a, b
 getchr    equ  0121h  ; a
 getchrx   equ  0124h  ; a
 init      equ  0127h
 inkey     equ  012ah  ; a
 mdelay    equ  012dh  ; a
 os_return equ  0130h
 percent   equ  0133h  ; a
 print     equ  0136h  ; a, dptr
 prsphx    equ  0139h  ; a, r2
 prtstr    equ  013ch  ; a
 prthex    equ  013fh  ; a, r2
 sdelay    equ  0142h  ; a
 setintvec equ  0145h  ; a, dptr
 sndchr    equ  0148h  ; a
; ----------------------------------------------------

    org 8000h
start:
    mov   r0, #10
loop:
    mov   a, #10
    lcall delay
    cpl   P1.0
    djnz  r0, loop
    cpl   P1.1
    sjmp  start

; ====================================================
;
; end of program
